
COMMENT	#

	This file is a part of OOG package by MazeGen
	- for more info read oog.txt

	This file contains all important encodings of the ModR/M
	and SIB bytes with given reasons for each selected encoding

	These encodings are used with ADD mnemonic:
	opcode 00, 8-bit operands, bit direction=0
	opcode 03, 16/32-bit operands, bit direction=1

	#

; Mod=11, never SIB byte
; Reason: test 8-bit, 16-bit and 32-bit registers

OOG <CH,DL>,  <000,0D5>
OOG <eDX,eBP>,<003,0D5>

; Mod=00 without SIB
; Reason: stand-alone base register in 16-bit memory access size (only BX)

OOG <[EDI],DH ; [BX],DH>,  <000,037>
OOG <eSI,[EDI] ; eSI,[BX]>,<003,037>

; Mod=00 without SIB
; Reason: stand-alone index register in 16-bit memory access size

OOG <[disp32],DH ; [DI],DH>,  <000,035,LDi>,<>,<000,035>
OOG <eSI,[disp32] ; eSI,[DI]>,<003,035,LDi>,<>,<003,035>

; Mod=00 without SIB
; Reason: Stand-alone displacement, no base nor index register

OOG <[disp32],DH ; [disp16],DH>,  <000,035,LDi>,<>,<000,036,SDi>
OOG <eSI,[disp32] ; eSI,[disp16]>,<003,035,LDi>,<>,<003,036,SDi>

; Mod=00 without SIB
; Reason: Stand-alone base register in 32-bit memory access size
;         Base-plus-index form in 16-bit memory access size

OOG <[EBX],DH ; [BP+DI],DH>,  <000,033>
OOG <eSI,[EBX] ; eSI,[BP+DI]>,<003,033>

; Mod=00 without SIB
; Reason: Stand-alone index register in 32-bit memory access size
;         Base-plus-index form in 16-bit memory access size

OOG <[EDX],DH ; [BP+SI],DH>,  <000,032>
OOG <eSI,[EDX] ; eSI,[BP+SI]>,<003,032>

; Mod=01 without SIB
; Reason: 8-bit displacement

OOG <[EDX+disp8],DH ; [BP+SI+disp8],DH>,  <000,072,BDi>
OOG <eSI,[EDX+disp8] ; eSI,[BP+SI+disp8]>,<003,072,BDi>

; Mod=10 without SIB
; Reason: 16/32-bit displacement in 16/32-bit memory access size

OOG <[EDX+disp32],DH ; [BP+SI+disp16],DH>,  <000,0B2,LDi>,<>,<000,0B2,SDi>
OOG <eSI,[EDX+disp32] ; eSI,[BP+SI+disp16]>,<003,0B2,LDi>,<>,<003,0B2,SDi>

;---	SIB	---

; Mod=00 with SIB
; Reason: SIB.index=100 (unused) with SIB.base=101 results in [disp32]

OOG <[disp32],AH ; [SI],AH>,  <000,024,025,LDi>,<>,<000,024>
OOG <eSP,[disp32] ; eSP,[SI]>,<003,024,065,LDi>,<>,<003,024>	; unused scale factor *2

; Mod=00 with SIB
; Reason: SIB.index=100 - unused

OOG <[ESP],AH ; [SI],AH>,  <000,024,024>,<>,<000,024>
OOG <eSP,[ESP] ; eSP,[SI]>,<003,024,0A4>,<>,<003,024>		; unused scale factor *4

; Mod=00 with SIB
; Reason: Base-plus-index form

OOG <[EDX+ESI*4],AH ; [SI],AH>,  <000,024,0B2>,<>,<000,024>
OOG <eSP,[EDX+ESI*8] ; eSP,[SI]>,<003,024,0F2>,<>,<003,024>

;
; Mod=01 with SIB
; Reason: SIB.index=100 - unused

OOG <[ESI+disp8],AH ; [SI+disp8],AH>,  <000,064,026,BDi>,<>,<000,064,BDi>
OOG <eSP,[ESI+disp8] ; eSP,[SI+disp8]>,<003,064,066,BDi>,<>,<003,064,BDi>	; unused scale factor *2

; Mod=01 with SIB
; Reason: Base-plus-index form

OOG <[EDX+ESI+disp8],AH ; [SI+disp8],AH>,    <000,064,032,BDi>,<>,<000,064,BDi>
OOG <eSP,[EDX+ESI*4+disp8] ; eSP,[SI+disp8]>,<003,064,0B2,BDi>,<>,<003,064,BDi>

;
; Mod=10 with SIB
; Reason: SIB.index=100 - unused

OOG <[ESI+disp32],AH ; [SI+disp16],AH>,  <000,0A4,026,LDi>,<>,<000,0A4,SDi>
OOG <eSP,[ESI+disp32] ; eSP,[SI+disp16]>,<003,0A4,066,LDi>,<>,<003,0A4,SDi>	; unused scale factor *2

; Mod=10 with SIB
; Reason: Base-plus-index form

OOG <[EDX+ESI+disp32],AH ; [SI+disp16],AH>,    <000,0A4,032,LDi>,<>,<000,0A4,SDi>
OOG <eSP,[EDX+ESI*4+disp32] ; eSP,[SI+disp16]>,<003,0A4,0B2,LDi>,<>,<003,0A4,SDi>
